//Jonas Norling 2000
//GPL

#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include "mandel.h"
#include "julia.h"

void printhelp(char* error)
{
  fprintf(stderr, "%s\n\n", error);

  fprintf(stderr, "%s <re> <im> <radius> <as> <dwell> <width> <colouring> <type>\n", "fractalgen");

  fprintf(stderr, "re:\tThe fractals center point, real coordinate\n"
	  "im:\tThe fractals center point, imaginary coordinate\n"
	  "radius\tThe size of the fractal, given as a radius from the center point\n"
	  "as:\tAspect ratio. 1.25 for standard computer screen aspect\n"
	  "dwell:\tDwell limit. Maximum iterations\n"
	  "width:\tImage width in pixels\n"
	  "colouring:\tColour scheme\n"
	  "\n");

  fprintf(stderr, "type:"
	 "\tmandel\n"
	 "\tjulia\n"
	 "\n");

  fprintf(stderr, "colouring:"
	  "\t%d\tCOLOUR\n"
	  "\t\t%d\tBW\n"
	  "\n", COLOUR, BW);

  fprintf(stderr, "Example:\n"
	  "\tfractalgen -0.7 0 1.5 1.25 60 640 1 mandel\n"
	  "\n");

  fprintf(stderr, "Copyright 2001 Jonas Norling. GNU GPL applies\n");
}

int main(int argc, char* argv[])
{
  double re, im, ra, as;
  int dwell, width, col;

  if (argc != 9) {
    printhelp("Wrong number of arguments");
    exit(2);
  }

  re = strtod(argv[1], NULL);
  im = strtod(argv[2], NULL);
  ra = strtod(argv[3], NULL);
  as = strtod(argv[4], NULL);
  dwell = atoi(argv[5]);
  width = atoi(argv[6]);
  col = atoi(argv[7]);

  if (!strcasecmp(argv[8], "mandel")) {
    (new Mandel())->render(re, im, ra, as, dwell, width, col);
  } else if (!strcasecmp(argv[8], "julia")) {
    (new Julia())->render(re, im, ra, as, dwell, width, col);
  } else {
    printhelp("Invalid fractal type");
    exit(2);
  }
}

